### 自定义MQTT交互接口

#### 修改日志
- 2021-04-21:
  - xxx


#### 上行payload中的公共参数

```javascript
{
    "device_name": {device_name},
    "lan_ip": {lan_ip},
    "timestamp": {timestamp}
}
```

device_name、lan_ip都是字符型，timestamp是整型，为10位数的时间戳



#### 上行

| Function         | Topic                                                    | Payload                                                      | Remark                          |
| ---------------- | -------------------------------------------------------- | ------------------------------------------------------------ | ------------------------------- |
| 关机上报         | /{productID}/{deviceName}/up/device_state_changed        | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"state": "off",  "auto": true}} | 自动关机时auto传true，手动传false |
| 开机上报         | /{productID}/{deviceName}/up/device_state_changed        | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"state": "on"}} |                                 |
| 指令执行完成上报 | /{productID}/{deviceName}/up/commands_execution_finished | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"success": true}} | 成功传true，失败传false         |
| 缓存数据超时     | /{productID}/{deviceName}/up/cache_timed_out             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"cache_id": "1"} |                                 |
| 设备上报当前版本号     | /{productID}/{deviceName}/up/ota             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_version", "version": "0.1"}} |                                 |
| 设备上报下载进度     | /{productID}/{deviceName}/up/ota             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_progress", "version": "0.1", "state": "downloading", "percent":"10"}} |                                 |
| 设备开始升级     | /{productID}/{deviceName}/up/ota             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_progress", "version": "0.1", "state": "burning"}} |                                 |
| 上报升级成功     | /{productID}/{deviceName}/up/ota             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_progress", "version": "0.1", "state": "done"}} |                                 |
| 上报升级失败     | /{productID}/{deviceName}/up/ota             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_progress", "version": "0.1", "state": "fail", "reason": "timeout"}} |                                 |
| 发起指令序列上传任务     | /{productID}/{deviceName}/up/commands_upload             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "request_upload}} |                                 |
| 上报指令序列上传成功     | /{productID}/{deviceName}/up/commands_upload             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_state", "success": true, "url": "xxx"}} |                                 |
| 上报指令序列上传失败     | /{productID}/{deviceName}/up/commands_upload             | {"device_name": "device1", "lan_ip": "192.168.1.2", "timestamp": 1618903842, "params": {"type": "report_state", "success": false, "url": "xxx"}} |                                 |



#### 下行

| Function            | Topic                                                | Payload                          | Remark              |
| ------------------- | ---------------------------------------------------- | -------------------------------- | ------------------- |
| 下发指令序列上传地址        | /{productID}/{deviceName}/down/commands_upload   | {"url": "https://xxx.yyy.zzz"} |                     |
| 下发升级包链接| /{productID}/{deviceName}/down/ota | {"version": "0.2", "packages": [{"url": "xxx", "file_size": "xxx", "md5sum": "xxx"}, {"url": "xxx", "file_size": "xxx", "md5sum": "xxx"}]}           |      |

